clear all
close all



    %settings
    nmbOfRep=1;
    idx_figure=1;
    ptd=100;%percentage of train data
    plotMhist=1;%for GMM plots x and y axis of cluster means during time in log scale
    classifier=1; %1-GMM,2-kmeans, 3- diaglinear
    datasets=[1 3 4 5 6]%1=iris,2=9cl,3=s1,4=s2,5=s3,6=s4,8=dataFeatureSelectionNG
    
    
for idx_dataset=datasets
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %load data,1=iris,2=9cl,3=s1,4=s2,5=s3,6=s4,8=dataFeatureSelectionNG
    [v,labels]=LoadingData(idx_dataset);
    nmbCl=size(unique(labels),2);

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %normalization of data,type-1=v/max,2=(v-min)/(max-min)
    type=2;
    v=normalize(v,type);

    for repetition=1:nmbOfRep
        %supervised
        options = statset('Display','final');hold on;
        obj = gmdistribution.fit(v',nmbCl,'Start',labels,'Options',options);
        idx = cluster(obj,v');
        [accuracy]=Minimum_testClassification2(idx',labels)

        resultsGMM_Sup{idx_dataset}.accuracy(repetition)=accuracy;
        resultsGMM_Sup{idx_dataset}.distribution{repetition}=obj;
        resultsGMM_Sup{idx_dataset}.outlabels{repetition}=idx;
         if repetition==nmbOfRep
             figure(idx_figure);idx_figure=idx_figure+1;
             scatter(v(1,:),v(2,:),10,'.');hold on;
             h = ezcontour(@(x,y)pdf(obj,[x y]));
         end
        
        %unsupervised known number of clusters
        options = statset('Display','final');hold on;
        obj = gmdistribution.fit(v',nmbCl,'Options',options);
        idx = cluster(obj,v');
        [accuracy]=Minimum_testClassification2(idx',labels)

        resultsGMM_Unsup{idx_dataset}.accuracy(repetition)=accuracy;
        resultsGMM_Unsup{idx_dataset}.distribution{repetition}=obj;
        resultsGMM_Unsup{idx_dataset}.outlabels{repetition}=idx;
         if repetition==nmbOfRep
             figure(idx_figure);idx_figure=idx_figure+1;
             scatter(v(1,:),v(2,:),10,'.');hold on;
             h = ezcontour(@(x,y)pdf(obj,[x y]));
         end
    end
end
